#include "aliases.h"
#include "tiffread.h"
#include <netinet/in.h>
#include <stdio.h>
#include <string.h>

int main(int argc, char *argv[]) {
  const char *file_to_open = argc > 1 ? argv[1] : "./resources/test.tif";

  FILE *fp = fopen(file_to_open, "r");

  TiffHdr header;
  TiffIFD ifd = {0};

  fread(&header, sizeof(TiffHdr), 1, fp);

  printf("ORDER: %04x\n", header.order);
  printf("MAGIC: %04x\n", header.magic);

  fseek(fp, header.first_ifd_offset, SEEK_SET);

  fread(&(ifd.count), sizeof(ifd.count), 1, fp);

  printf("COUNT: %u\n", ifd.count);

  TiffField fields[ifd.count];
  memset(fields, 0, sizeof(TiffField) * ifd.count);

  for (u32 i = 0; i < ifd.count; ++i) {
    fread(fields + i, sizeof(TiffField), 1, fp);
    printf("ENTRY %02u\n", i);
    printf("\t    TAG: %04u (%s)\n", fields[i].tag,
           tag_names[fields[i].tag] ? tag_names[fields[i].tag] : "UNKNOWN");
    printf("\t   TYPE: 0x%04x (%s)\n", fields[i].type,
           filed_type_names[fields[i].type] ? filed_type_names[fields[i].type]
                                            : "UNKNOWN");
    printf("\t  COUNT: %04u\n", fields[i].count);
    printf("\tVAL/OFF: %04u\n", fields[i].value_offset);
  }

  fclose(fp);

  return 0;
}
